//
//  ViewController.m
//  demo
//
//  Created by 季怀斌 on 16/6/8.
//  Copyright © 2016年 huazhuo. All rights reserved.
//

#import "ViewController.h"
#import "HZTabBarController.h"
#import "HZLeftViewController.h"

#import "HZMidViewController.h"
@interface ViewController ()<HZLeftViewControllerDelegate>
@property (nonatomic, strong) UINavigationController *navCtr;
@property (nonatomic, strong) HZTabBarController *tabBarCtr;

@property (nonatomic, strong)UIButton *cover;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.

    HZTabBarController *tabBarCtr = [[HZTabBarController alloc] init];
    UINavigationController *navCtr = [[UINavigationController alloc] initWithRootViewController:tabBarCtr];
    [self.view addSubview:navCtr.view];
    [self addChildViewController:navCtr];
    self.navCtr = navCtr;
    self.tabBarCtr = tabBarCtr;
    
    //
    HZLeftViewController *leftVC = [[HZLeftViewController alloc] init];
    UINavigationController *leftNavCtr = [[UINavigationController alloc] initWithRootViewController:leftVC];
    [self.view insertSubview:leftVC.view atIndex:0];
    leftVC.view.backgroundColor = [UIColor yellowColor];
    [self addChildViewController:leftNavCtr];
    
    leftVC.delegate = self;
    
    //
    UIButton *btn = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, 30, 30)];
    btn.backgroundColor = [UIColor greenColor];
    [btn addTarget:self action:@selector(btnClick:) forControlEvents:UIControlEventTouchUpInside];
    self.tabBarCtr.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:btn];

//    //
//    UIPanGestureRecognizer *pan = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(pan:)];
//    [self.navCtr.view addGestureRecognizer:pan];
}


- (void)btnClick:(UIButton *)btn {

    
    [UIView animateWithDuration:0.25 animations:^{
        
        UIView *mainView = self.navCtr.view;
        
    CGAffineTransform translateForm = CGAffineTransformTranslate(mainView.transform, 200, 0);
        mainView.transform = translateForm;
        
        // 添加一个遮盖
        UIButton *cover = [[UIButton alloc] init];
//        cover.tag = HMCoverTag;
        [cover addTarget:self action:@selector(coverClick:) forControlEvents:UIControlEventTouchUpInside];
        cover.frame = mainView.bounds;
        [mainView addSubview:cover];
        self.cover = cover;

    }];
    
}


- (void)coverClick:(UIView *)cover {
    [UIView animateWithDuration:0.25 animations:^{
        self.navCtr.view.transform = CGAffineTransformIdentity;
    } completion:^(BOOL finished) {
        [cover removeFromSuperview];
    }];
}

- (void)putIntoViewController {
    [self coverClick:self.cover];
    HZMidViewController *VC = [[HZMidViewController alloc] init];
    [self.navCtr pushViewController:VC animated:NO];
}

//
//- (void)pan:(UIPanGestureRecognizer *)pan {
//    CGFloat offsetX = [pan translationInView:self.navCtr.view].x;
//    NSLog(@"%lf", offsetX);
//    UIView *mainView = self.navCtr.view;
//    
//  if ([self frameWithOfsetX:offsetX].origin.x <= 0) return;
//    
//    CGAffineTransform translateForm = CGAffineTransformTranslate(mainView.transform, offsetX, 0);
//    mainView.transform = translateForm;
//    
//    [pan setTranslation:CGPointZero inView:mainView];
//    
//    
//
//
//    
////     if (pan.state == UIGestureRecognizerStateEnded) {
////    
////     }
////    
////    // 添加一个遮盖
////    UIButton *cover = [[UIButton alloc] init];
////    //        cover.tag = HMCoverTag;
////    [cover addTarget:self action:@selector(coverClick:) forControlEvents:UIControlEventTouchUpInside];
////    cover.frame = mainView.bounds;
////    [mainView addSubview:cover];
//
//}
//
//
//- (CGRect)frameWithOfsetX:(CGFloat)offsetX {
//    CGRect frame = self.navCtr.view.frame;
//    frame.origin.x += offsetX;
//    
//    return frame;
//}
@end
